#version 120

uniform int flag;
uniform int norFlag;
varying vec3 vCol;
varying vec4 vNor;
varying vec3 vlightSrc;
varying vec3 vDiffuseClr;
varying vec3 vAmbientClr;
varying vec3 vSpecColor;
varying float vShine;
varying vec3 vViewVec;
varying vec3 vLightVec;

void main()
{

	vec3 diffuseClr = vDiffuseClr;
	vec3 specClr = vSpecColor;
	vec3 ambientClr = vAmbientClr;
	float shine = vShine;

	if(flag == 0)
	{
		diffuseClr = vDiffuseClr;
		specClr = vSpecColor;
		ambientClr = vAmbientClr;
		shine = vShine;
	}
	else if(flag == 1)
	{
		//diffuseClr = vec3(37.0f/255.0f, 165.0f/255.0f, 5.0f/255.0f);
		diffuseClr = vec3(20.0f/255.0f, 194.0f/255.0f, 23.0f/255.0f);
		//specClr = vec3(0.1, 0.1, 0.1);
		specClr = vec3(0, 0, 0);
		//ambientClr = vec3(37.0f/255.0f, 165.0f/255.0f, 5.0f/255.0f);
		ambientClr = vec3(0, 0, 0);
		shine = 4.0f;
	}

	vec3 viewVec = normalize(vViewVec);
	vec3 lightSrc = (vLightVec);
	vec3 halfVec = normalize(lightSrc + viewVec);

	float max2 = pow(max(0, dot(normalize(vec3(vNor)), normalize(halfVec))), shine);
	float max = max(0, dot(normalize(vec3(vNor)), normalize(lightSrc)));

	diffuseClr *= max;
	specClr *= max2;

	gl_FragColor = vec4(diffuseClr.x + ambientClr.x + specClr.x,
		diffuseClr.y + ambientClr.y + specClr.y,
		diffuseClr.z + ambientClr.z + specClr.z, 1.0);
}
