// Base code for program 3 - does not compile as is, needs other files 
//and shaders but has skeleton for much of the data transfer for shading
//and traversal of the mesh for computing normals - you must compute normals

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <cassert>
#include <cmath>
#include <stdio.h>
#include "GLSL.h"
#include "tiny_obj_loader.h"
#include "glm/glm.hpp"
#include "glm/gtc/matrix_transform.hpp" //perspective, trans etc
#include "glm/gtc/type_ptr.hpp" //value_ptr

#include <glew.h>
#include <glfw3.h>

GLFWwindow* window;
using namespace std;
using namespace glm;

vector<tinyobj::shape_t> cube;
vector<tinyobj::shape_t> sphere;
vector<tinyobj::shape_t> bunny;
vector<tinyobj::shape_t> tree;
vector<tinyobj::shape_t> gun;
vector<tinyobj::material_t> materials;

int norFlag = 0;
int g_SM = 0;
int g_width;
int g_height;
static int width = 1024;
static int height = 768;

//float g_Camtrans = -2.5;
float g_Camtrans = 0;
float g_angle = 0;
float g_xAngle = 0;
float theta = 0;
float phi = 0;
int g_mat_id =3;
float mouseSpeed = 0.01f;
float moveSpeed = 2.0f;
float curTime = 0;
float radius = 5;
float outsideRadius = 25.0f;
float jumpPower = 5.0f;
float gravity = -10.0f;
glm::vec3 g_trans(0, 0, -4);
glm::vec3 g_light(10, 30, 10);
glm::vec3 Eye = glm::vec3(0, 0, 0);
glm::vec3 viewVec(0, 0 ,0);
glm::vec3 LookAt(0, 0, 0);
glm::vec3 direction(0, 0, 0);
glm::vec3 up(0, 0, 0);
glm::vec3 leaderPoint(0, 0, -18);
vec3 newLeaderPos(0, 0 ,-18);
mat4 shotMat;

GLuint ShadeProg;
GLuint posBufObjB = 0;
GLuint norBufObjB = 0;
GLuint indBufObjB = 0;

GLuint posBufObjG = 0;
GLuint norBufObjG = 0;

GLuint posBufObjF = 0;
GLuint norBufObjF = 0;

GLuint posBufObjS = 0;
GLuint norBufObjS = 0;
GLuint indBufObjS = 0;

GLuint posBufObjC = 0;
GLuint norBufObjC = 0;
GLuint indBufObjC = 0;

GLuint posBufObjTree = 0;
GLuint norBufObjTree = 0;
GLuint indBufObjTree = 0;

GLuint posBufObjGun = 0;
GLuint norBufObjGun = 0;
GLuint indBufObjGun = 0;

int minTreeX = 0;
int maxTreeX = 0;
int minTreeZ = 0;
int maxTreeZ = 0;

int minBunX = 0;
int maxBunX = 0;
int minBunZ = 0;
int maxBunZ = 0;

//Handles to the shader data
GLint h_aPosition;
GLint h_aNormal;
GLint h_uModelMatrix;
GLint h_uViewMatrix;
GLint h_uProjMatrix;
GLint h_uLightPos;
GLint h_uMatAmb, h_uMatDif, h_uMatSpec, h_uMatShine;
GLint h_uShadeM;
GLint uFlag;
GLint uNorFlag;

bool canJump = true;
bool shooting = false;

struct POINT {
  double x;
  double y;
};

POINT point;

struct BOID {
  vec3 pos;
  vec3 velocity;
  bool jumping;
  bool falling;
  bool shot;
  float size;
};

struct BULLET {
  vec3 pos;
  float speed;
  bool inRange;
};

BOID buns[20];
BULLET buls[5];

mat4 projection_matrix;
mat4 view_matrix;

static GLfloat bunnyPositions[20] = {0};
static GLfloat treePositions[20] = {0};

/* helper function to make sure your matrix handle is correct */
inline void safe_glUniformMatrix4fv(const GLint handle, const GLfloat data[]) {
  if (handle >= 0)
    glUniformMatrix4fv(handle, 1, GL_FALSE, data);
}

/* helper function to send materials to the shader - you must create your own */
void SetMaterial(int i) {
 
  glUseProgram(ShadeProg);
  switch (i) {
    case 0: //shiny blue plastic
        glUniform3f(h_uMatAmb, 0.02, 0.02, 0.1);
        glUniform3f(h_uMatDif, 0.0, 0.08, 0.5);
        glUniform3f(h_uMatSpec, 0.14, 0.14, 0.4);
        glUniform1f(h_uMatShine, 120.0);
        break;
    case 1: // flat grey
        glUniform3f(h_uMatAmb, 0.13, 0.13, 0.14);
        glUniform3f(h_uMatDif, 0.3, 0.3, 0.4);
        glUniform3f(h_uMatSpec, 0.3, 0.3, 0.4);
        glUniform1f(h_uMatShine, 4.0);
        break;
    case 2: //gold
        glUniform3f(h_uMatAmb, 0.09, 0.07, 0.08);
        glUniform3f(h_uMatDif, 0.91, 0.782, 0.82);
        glUniform3f(h_uMatSpec, 1.0, 0.913, 0.8);
        glUniform1f(h_uMatShine, 200.0);
        break;
    case 3: //Chrome
        glUniform3f(h_uMatAmb, .25, .25, .25);
        glUniform3f(h_uMatDif, .4, .4, .4);
        glUniform3f(h_uMatSpec, .774597, .774597, .774597);
        glUniform1f(h_uMatShine, 76.8);
        break;
    case 4: //Jade
        glUniform3f(h_uMatAmb, 0.135, 0.2225, 0.1575);
        glUniform3f(h_uMatDif, 0.54, .89, .63);
        glUniform3f(h_uMatSpec, .316228, 0.316228, 0.316228);
        glUniform1f(h_uMatShine, 12.8);
        break;
    case 5: //Sun
        glUniform3f(h_uMatAmb, .7, .5, 0);
        glUniform3f(h_uMatDif, .7, .5, 0);
        glUniform3f(h_uMatSpec, 0, 0, 0);
        glUniform1f(h_uMatShine, 200);
        break;
    case 6: //Fire
        glUniform3f(h_uMatAmb, .7, 0, 0);
        glUniform3f(h_uMatDif, .7, 0, 0);
        glUniform3f(h_uMatSpec, 0, 0, 0);
        glUniform1f(h_uMatShine, 200);
        break;
  }
}

/* helper function to set projection matrix - don't touch */
void SetProjectionMatrix() {
  glm::mat4 Projection = projection_matrix = glm::perspective(90.0f, (float)g_width/g_height, 0.1f, 100.f);
  safe_glUniformMatrix4fv(h_uProjMatrix, glm::value_ptr(Projection));
}

/* camera controls - do not change beyond the current set up to rotate*/
void SetView() {

  //Gets current mouse position
  glfwGetCursorPos(window, &point.x, &point.y);

  //Gets angle from (0, 0) to the current mouse position
  theta = mouseSpeed * float(1024/2 - point.x);
  phi = mouseSpeed * float(768/2 - point.y);

  //Limits the maximum Y angle to 180
  if(phi > (1.4f))
  {
    phi = 1.4f;
  }
  else if(phi < -(1.4f))
  {
    phi = -1.4;
  }

  //Computes the LookAt point
  float x = cos(phi) * sin(theta);
  float y = sin(phi);
  float z = cos(phi) * cos(theta);
  LookAt = glm::vec3(x, y, z);

  //Computes up vector - this is not necessary
  glm::vec3 right = glm::vec3(sin(theta - 3.14f/2.0f),
    0,
    cos(theta - 3.14f/2.0f));
  up = glm::cross(right, LookAt);

  //Computes viewVector
  viewVec = glm::normalize(LookAt - Eye);

  //Passes the View Matrix to the Shaders
  //glm::mat4 viewMat = glm::lookAt(Eye + direction, LookAt + direction, up);

  glm::mat4 viewMat = view_matrix = glm::lookAt(Eye + vec3(direction.x, 1, direction.z),
    LookAt + vec3(direction.x, 1, direction.z), up);
  safe_glUniformMatrix4fv(h_uViewMatrix, glm::value_ptr(viewMat));

}


/* model transforms */
void SetModel(vec3 trans, float rot, float sc) {
  glm::mat4 Trans = glm::translate( glm::mat4(1.0f), trans);
  glm::mat4 RotateY = glm::rotate( glm::mat4(1.0f), rot, glm::vec3(0.0f, 1, 0));
  glm::mat4 Sc = glm::scale( glm::mat4(1.0f), vec3(sc));
  glm::mat4 com = Trans*RotateY*Sc;
  safe_glUniformMatrix4fv(h_uModelMatrix, glm::value_ptr(com));
}

//Given a vector of shapes which has already been read from an obj file
// resize all vertices to the range [-1, 1]
void resize_obj(std::vector<tinyobj::shape_t> &shapes){
    float minX, minY, minZ;
    float maxX, maxY, maxZ;
    float scaleX, scaleY, scaleZ;
    float shiftX, shiftY, shiftZ;
    float epsilon = 0.001;

    minX = minY = minZ = 1.1754E+38F;
    maxX = maxY = maxZ = -1.1754E+38F;

    //Go through all vertices to determine min and max of each dimension
    for (size_t i = 0; i < shapes.size(); i++) {
        for (size_t v = 0; v < shapes[i].mesh.positions.size() / 3; v++) {
            if(shapes[i].mesh.positions[3*v+0] < minX) minX = shapes[i].mesh.positions[3*v+0];
            if(shapes[i].mesh.positions[3*v+0] > maxX) maxX = shapes[i].mesh.positions[3*v+0];

            if(shapes[i].mesh.positions[3*v+1] < minY) minY = shapes[i].mesh.positions[3*v+1];
            if(shapes[i].mesh.positions[3*v+1] > maxY) maxY = shapes[i].mesh.positions[3*v+1];

            if(shapes[i].mesh.positions[3*v+2] < minZ) minZ = shapes[i].mesh.positions[3*v+2];
            if(shapes[i].mesh.positions[3*v+2] > maxZ) maxZ = shapes[i].mesh.positions[3*v+2];
        }
    }
   //From min and max compute necessary scale and shift for each dimension
   float maxExtent, xExtent, yExtent, zExtent;
   xExtent = maxX-minX;
   yExtent = maxY-minY;
   zExtent = maxZ-minZ;
   if (xExtent >= yExtent && xExtent >= zExtent) {
     maxExtent = xExtent;
   }
   if (yExtent >= xExtent && yExtent >= zExtent) {
     maxExtent = yExtent;
   }
   if (zExtent >= xExtent && zExtent >= yExtent) {
     maxExtent = zExtent;
   }
    scaleX = 2.0 /maxExtent;
    shiftX = minX + (xExtent/ 2.0);
    scaleY = 2.0 / maxExtent;
    shiftY = minY + (yExtent / 2.0);
    scaleZ = 2.0/ maxExtent;
    shiftZ = minZ + (zExtent)/2.0;

    //Go through all verticies shift and scale them
    for (size_t i = 0; i < shapes.size(); i++) {
        for (size_t v = 0; v < shapes[i].mesh.positions.size() / 3; v++) {
            shapes[i].mesh.positions[3*v+0] = (shapes[i].mesh.positions[3*v+0] - shiftX) * scaleX;
            assert(shapes[i].mesh.positions[3*v+0] >= -1.0 - epsilon);
            assert(shapes[i].mesh.positions[3*v+0] <= 1.0 + epsilon);
            shapes[i].mesh.positions[3*v+1] = (shapes[i].mesh.positions[3*v+1] - shiftY) * scaleY;
            assert(shapes[i].mesh.positions[3*v+1] >= -1.0 - epsilon);
            assert(shapes[i].mesh.positions[3*v+1] <= 1.0 + epsilon);
            shapes[i].mesh.positions[3*v+2] = (shapes[i].mesh.positions[3*v+2] - shiftZ) * scaleZ;
            assert(shapes[i].mesh.positions[3*v+2] >= -1.0 - epsilon);
            assert(shapes[i].mesh.positions[3*v+2] <= 1.0 + epsilon);
        }
    }
}



void loadShapes(const string &objFile, std::vector<tinyobj::shape_t>& shapes)
{
	string err = tinyobj::LoadObj(shapes, materials, objFile.c_str());
	if(!err.empty()) {
		cerr << err << endl;
	}
   resize_obj(shapes);
}

void initBunny(std::vector<tinyobj::shape_t>& shape) {

	// Send the position array to the GPU
	const vector<float> &posBuf = shape[0].mesh.positions;

  for(int i = 0; i < shape[0].mesh.positions.size()/3; i++)
  {

    vec3 v1 = glm::vec3(shape[0].mesh.positions[3*i+0],
      shape[0].mesh.positions[3*i+1],
      shape[0].mesh.positions[3*i+2]);


    if(v1.x > maxBunX)
    {
      maxBunX = v1.x;
    }

    if(v1.x < minBunX)
    {
      minBunX = v1.x;
    }

    if(v1.z > maxBunZ)
    {
      maxBunZ = v1.z;
    }

    if(v1.z < minBunZ)
    {
      minBunZ = v1.z;
    }
  }

  cout << "minx: " << minBunX << endl;
  cout << "maxx: " << maxBunX << endl;
  cout << "minz: " << minBunZ << endl;
  cout << "maxz: " << maxBunZ << endl;

	glGenBuffers(1, &posBufObjB);
	glBindBuffer(GL_ARRAY_BUFFER, posBufObjB);
	glBufferData(GL_ARRAY_BUFFER, posBuf.size()*sizeof(float), &posBuf[0], GL_STATIC_DRAW);
	
	// Send the normal array to the GPU
	vector<float> norBuf;
   glm::vec3 v1, v2, v3;
   glm::vec3 edge1, edge2, norm;
   int idx1, idx2, idx3;
   //for every vertex initialize the vertex normal to 0
   for (int j = 0; j < shape[0].mesh.positions.size()/3; j++) {
      norBuf.push_back(0);
      norBuf.push_back(0);
      norBuf.push_back(0);
   }
   //process the mesh and compute the normals - for every face
   //add its normal to its associated vertex
   for (int i = 0; i < shape[0].mesh.indices.size()/3; i++) {
      idx1 = shape[0].mesh.indices[3*i+0];
      idx2 = shape[0].mesh.indices[3*i+1];
      idx3 = shape[0].mesh.indices[3*i+2];
      v1 = glm::vec3(shape[0].mesh.positions[3*idx1 +0],shape[0].mesh.positions[3*idx1 +1], shape[0].mesh.positions[3*idx1 +2]);
      v2 = glm::vec3(shape[0].mesh.positions[3*idx2 +0],shape[0].mesh.positions[3*idx2 +1], shape[0].mesh.positions[3*idx2 +2]);
      v3 = glm::vec3(shape[0].mesh.positions[3*idx3 +0],shape[0].mesh.positions[3*idx3 +1], shape[0].mesh.positions[3*idx3 +2]);
      edge1 = v2 - v1;
      edge2 = v3 - v1;
      norm = glm::cross(edge1, edge2);
      norBuf[3*idx1+0] += (norm.x);
      norBuf[3*idx1+1] += (norm.y);
      norBuf[3*idx1+2] += (norm.z);
      norBuf[3*idx2+0] += (norm.x);
      norBuf[3*idx2+1] += (norm.y);
      norBuf[3*idx2+2] += (norm.z);
      norBuf[3*idx3+0] += (norm.x);
      norBuf[3*idx3+1] += (norm.y);
      norBuf[3*idx3+2] += (norm.z);
   }
	glGenBuffers(1, &norBufObjB);
	glBindBuffer(GL_ARRAY_BUFFER, norBufObjB);
	glBufferData(GL_ARRAY_BUFFER, norBuf.size()*sizeof(float), &norBuf[0], GL_STATIC_DRAW);
	
	// Send the index array to the GPU
	const vector<unsigned int> &indBuf = shape[0].mesh.indices;
	glGenBuffers(1, &indBufObjB);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, indBufObjB);
	glBufferData(GL_ELEMENT_ARRAY_BUFFER, indBuf.size()*sizeof(unsigned int), &indBuf[0], GL_STATIC_DRAW);

	// Unbind the arrays
	glBindBuffer(GL_ARRAY_BUFFER, 0);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
	GLSL::checkVersion();
	assert(glGetError() == GL_NO_ERROR);
}

void initGround() {

  float G_edge = 50;
  GLfloat g_backgnd_data[] = {
      -G_edge, -1.0f, -G_edge,
        -G_edge,  -1.0f, G_edge,
        G_edge, -1.0f, -G_edge,
        -G_edge,  -1.0f, G_edge,
        G_edge, -1.0f, -G_edge,
        G_edge, -1.0f, G_edge,
  };


  GLfloat nor_Buf_G[] = { 
      0.0f, 1.0f, 0.0f,
      0.0f, 1.0f, 0.0f,
      0.0f, 1.0f, 0.0f,
      0.0f, 1.0f, 0.0f,
      0.0f, 1.0f, 0.0f,
      0.0f, 1.0f, 0.0f,
  };

  glGenBuffers(1, &posBufObjG);
  glBindBuffer(GL_ARRAY_BUFFER, posBufObjG);
  glBufferData(GL_ARRAY_BUFFER, sizeof(g_backgnd_data), g_backgnd_data, GL_STATIC_DRAW);
	
  glGenBuffers(1, &norBufObjG);
	glBindBuffer(GL_ARRAY_BUFFER, norBufObjG);
	glBufferData(GL_ARRAY_BUFFER, sizeof(nor_Buf_G), nor_Buf_G, GL_STATIC_DRAW);

}

void initFire()
{
  float G_edge = 50;
  GLfloat g_backgnd_data[] = {
      0, -1.0f, -1.0f,
      0, -1.0f, 1.0f,
      0, 1.0f, -1.0f,
      0, -1.0f, 1.0f,
      0, 1.0f, -1.0f,
      0, 1.0f, 1.0f,
};

  GLfloat nor_Buf_G[] = { 
        1.0f, 0.0f, 0.0f,
        1.0f, 0.0f, 0.0f,
        1.0f, 0.0f, 0.0f,
        1.0f, 0.0f, 0.0f,
        1.0f, 0.0f, 0.0f,
        1.0f, 0.0f, 0.0f,
    };

  glGenBuffers(1, &posBufObjF);
  glBindBuffer(GL_ARRAY_BUFFER, posBufObjF);
  glBufferData(GL_ARRAY_BUFFER, sizeof(g_backgnd_data), g_backgnd_data, GL_STATIC_DRAW);
  
  glGenBuffers(1, &norBufObjF);
  glBindBuffer(GL_ARRAY_BUFFER, norBufObjF);
  glBufferData(GL_ARRAY_BUFFER, sizeof(nor_Buf_G), nor_Buf_G, GL_STATIC_DRAW);
}

void initSphere(std::vector<tinyobj::shape_t>& shapes)
{
	const vector<float> &posBuf = shapes[0].mesh.positions;
	glGenBuffers(1, &posBufObjS);
	glBindBuffer(GL_ARRAY_BUFFER, posBufObjS);
	glBufferData(GL_ARRAY_BUFFER, posBuf.size()*sizeof(float), &posBuf[0], GL_STATIC_DRAW);
	
	// Send the index array to the GPU
	const vector<unsigned int> &indBuf = shapes[0].mesh.indices;
	glGenBuffers(1, &indBufObjS);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, indBufObjS);
	glBufferData(GL_ELEMENT_ARRAY_BUFFER, indBuf.size()*sizeof(unsigned int), &indBuf[0], GL_STATIC_DRAW);

	//Send the normal array to the GPU
	const vector<float> &norBuf = shapes[0].mesh.normals;
	glGenBuffers(1, &norBufObjS);
	glBindBuffer(GL_ARRAY_BUFFER, norBufObjS);
	glBufferData(GL_ARRAY_BUFFER, norBuf.size()*sizeof(float), &norBuf[0], GL_STATIC_DRAW);

	// Unbind the arrays
	glBindBuffer(GL_ARRAY_BUFFER, 0);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);

}

void initGun(std::vector<tinyobj::shape_t>& shapes)
{
  const vector<float> &posBuf = shapes[0].mesh.positions;
  glGenBuffers(1, &posBufObjGun);
  glBindBuffer(GL_ARRAY_BUFFER, posBufObjGun);
  glBufferData(GL_ARRAY_BUFFER, posBuf.size()*sizeof(float), &posBuf[0], GL_STATIC_DRAW);
  
  // Send the index array to the GPU
  const vector<unsigned int> &indBuf = shapes[0].mesh.indices;
  glGenBuffers(1, &indBufObjGun);
  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, indBufObjGun);
  glBufferData(GL_ELEMENT_ARRAY_BUFFER, indBuf.size()*sizeof(unsigned int), &indBuf[0], GL_STATIC_DRAW);

  //Send the normal array to the GPU
  const vector<float> &norBuf = shapes[0].mesh.normals;
  glGenBuffers(1, &norBufObjGun);
  glBindBuffer(GL_ARRAY_BUFFER, norBufObjGun);
  glBufferData(GL_ARRAY_BUFFER, norBuf.size()*sizeof(float), &norBuf[0], GL_STATIC_DRAW);

  // Unbind the arrays
  glBindBuffer(GL_ARRAY_BUFFER, 0);
  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);

}

void initCube(std::vector<tinyobj::shape_t>& shapes)
{
	glEnable(GL_DEPTH_TEST);
	
	// Send the position array to the GPU
	const vector<float> &posBuf = shapes[0].mesh.positions;
	glGenBuffers(1, &posBufObjC);
	glBindBuffer(GL_ARRAY_BUFFER, posBufObjC);
	glBufferData(GL_ARRAY_BUFFER, posBuf.size()*sizeof(float), &posBuf[0], GL_STATIC_DRAW);
	
	// Send the normal array to the GPU
	const vector<float> &norBuf = shapes[0].mesh.normals;
	glGenBuffers(1, &norBufObjC);
	glBindBuffer(GL_ARRAY_BUFFER, norBufObjC);
	glBufferData(GL_ARRAY_BUFFER, norBuf.size()*sizeof(float), &norBuf[0], GL_STATIC_DRAW);
	
	// Send the index array to the GPU
	const vector<unsigned int> &indBuf = shapes[0].mesh.indices;
	glGenBuffers(1, &indBufObjC);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, indBufObjC);
	glBufferData(GL_ELEMENT_ARRAY_BUFFER, indBuf.size()*sizeof(unsigned int), &indBuf[0], GL_STATIC_DRAW);

	// Unbind the arrays
	glBindBuffer(GL_ARRAY_BUFFER, 0);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
}

void initTree(std::vector<tinyobj::shape_t>& shapes)
{
  glEnable(GL_DEPTH_TEST);
  
  // Send the position array to the GPU
  const vector<float> &posBuf = shapes[0].mesh.positions;
  glGenBuffers(1, &posBufObjTree);
  glBindBuffer(GL_ARRAY_BUFFER, posBufObjTree);
  glBufferData(GL_ARRAY_BUFFER, posBuf.size()*sizeof(float), &posBuf[0], GL_STATIC_DRAW);
  
  // Send the normal array to the GPU
  const vector<float> &norBuf = shapes[0].mesh.normals;
  glGenBuffers(1, &norBufObjTree);
  glBindBuffer(GL_ARRAY_BUFFER, norBufObjTree);
  glBufferData(GL_ARRAY_BUFFER, norBuf.size()*sizeof(float), &norBuf[0], GL_STATIC_DRAW);
  
  // Send the index array to the GPU
  const vector<unsigned int> &indBuf = shapes[0].mesh.indices;
  glGenBuffers(1, &indBufObjTree);
  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, indBufObjTree);
  glBufferData(GL_ELEMENT_ARRAY_BUFFER, indBuf.size()*sizeof(unsigned int), &indBuf[0], GL_STATIC_DRAW);

  // Unbind the arrays
  glBindBuffer(GL_ARRAY_BUFFER, 0);
  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
}

void initGL()
{
	// Set the background color
	glClearColor(0.6f, 0.6f, 0.8f, 1.0f);
	// Enable Z-buffer test
	glEnable(GL_DEPTH_TEST);
   glPointSize(18);

   initCube(cube);
   initBunny(bunny);
   initSphere(sphere);
   initGround();
   initFire();
   initTree(tree);
   initGun(gun);
}

void setUpCubeModel(float x, float y, float z, int indices)
{
	glm::mat4 Trans = glm::translate( glm::mat4(1.0f), vec3(x, y, z));
  	mat4 ScaleY = glm::scale( glm::mat4(1.0f), glm::vec3(.25, .25, .25));
  	mat4 com = Trans*ScaleY;
 	safe_glUniformMatrix4fv(h_uModelMatrix, glm::value_ptr(com));

 	SetMaterial(1);

 	glDrawElements(GL_TRIANGLES, indices, GL_UNSIGNED_INT, 0);

 	mat4 Trans2 = translate(mat4(1.0f), vec3(0, 1, 0));
 	ScaleY = scale( glm::mat4(1.0f), glm::vec3(.75, .75, .75));
 	com = Trans * Trans2 * ScaleY;
 	safe_glUniformMatrix4fv(h_uModelMatrix, glm::value_ptr(com));

 	SetMaterial(2);

 	glDrawElements(GL_TRIANGLES, indices, GL_UNSIGNED_INT, 0);

 	mat4 Trans3 = translate(mat4(1.0f), vec3(0, 1.4, 0));
 	com = Trans * Trans2 * Trans3;
 	safe_glUniformMatrix4fv(h_uModelMatrix, glm::value_ptr(com));

 	SetMaterial(3);

 	glDrawElements(GL_TRIANGLES, indices, GL_UNSIGNED_INT, 0);
}

void setUpTreeModel(float x, float z, int indices)
{
  mat4 Scale = glm::scale(mat4(1.0f), vec3(3.0f, 3.0f, 3.0f));
  mat4 Rotate = glm::rotate(mat4(1.0f), -90.0f, vec3(1, 0, 0));
  mat4 Trans = glm::translate( glm::mat4(1.0f),
    vec3(x, 3, z));
  mat4 com = Trans * Rotate * Scale;
  safe_glUniformMatrix4fv(h_uModelMatrix, glm::value_ptr(com));

  glDrawElements(GL_TRIANGLES, indices, GL_UNSIGNED_INT, 0);
}

//Ask: Rotating to move gun in y dir
void setUpGunModel(int indices)
{
  mat4 ScaleY = glm::scale( glm::mat4(1.0f), glm::vec3(.15, .15, .15));
  mat4 Trans = glm::translate( glm::mat4(1.0f), vec3(-.1f, 0.80f, .25f));
  mat4 Trans2 = glm::translate( glm::mat4(1.0f), vec3(Eye.x + direction.x, 0, Eye.z + direction.z));
  mat4 Trans3 = glm::translate( glm::mat4(1.0f), vec3(1, 0, 0));
  mat4 Trans4 = glm::translate(glm::mat4(1.0f), vec3(-1, 0, 0));
  mat4 Rotate = rotate(mat4(1.0f), theta * (180.0f/3.14f), vec3(0, 1, 0));
  mat4 Rotate2 = rotate(mat4(1.0f), 180.0f, vec3(0, 1, 0));
  mat4 Rotate3 = rotate(mat4(1.0f), -phi * (180/3.14f), vec3(1, 0, 0));
  mat4 com = Trans2*Rotate*Trans*ScaleY*Trans4*Rotate3*Trans3*Rotate2;
  safe_glUniformMatrix4fv(h_uModelMatrix, glm::value_ptr(com));

  SetMaterial(1);

  glDrawElements(GL_TRIANGLES, indices, GL_UNSIGNED_INT, 0);
}

void setUpFireModel(int indices)
{
  mat4 ScaleY = glm::scale( glm::mat4(1.0f), glm::vec3(.05, .05, .05));
  mat4 Trans = glm::translate( glm::mat4(1.0f), vec3(-.1f, 0.85f, .40f));
  mat4 Trans2 = glm::translate( glm::mat4(1.0f), vec3(Eye.x + direction.x, 0, Eye.z + direction.z));
  mat4 Trans3 = glm::translate( glm::mat4(1.0f), vec3(-.25, 0, 0));
  mat4 Trans4 = glm::translate(glm::mat4(1.0f), vec3(.25, 0, 0));
  mat4 Rotate = rotate(mat4(1.0f), theta * (180.0f/3.14f), vec3(0, 1, 0));
  mat4 Rotate3 = rotate(mat4(1.0f), -phi * (90/3.14f), vec3(1, 0, 0));
  mat4 com = Trans2*Rotate*Rotate3*Trans*ScaleY;
  safe_glUniformMatrix4fv(h_uModelMatrix, glm::value_ptr(com));

  SetMaterial(6);

  glDrawElements(GL_TRIANGLES, indices, GL_UNSIGNED_INT, 0);
}

bool installShaders(const string &vShaderName, const string &fShaderName)
{
	GLint rc;
	
	// Create shader handles
	GLuint VS = glCreateShader(GL_VERTEX_SHADER);
	GLuint FS = glCreateShader(GL_FRAGMENT_SHADER);
	
	// Read shader sources
	const char *vshader = GLSL::textFileRead(vShaderName.c_str());
	const char *fshader = GLSL::textFileRead(fShaderName.c_str());
	glShaderSource(VS, 1, &vshader, NULL);
	glShaderSource(FS, 1, &fshader, NULL);
	
	// Compile vertex shader
	glCompileShader(VS);
	GLSL::printError();
	glGetShaderiv(VS, GL_COMPILE_STATUS, &rc);
	GLSL::printShaderInfoLog(VS);
	if(!rc) {
		printf("Error compiling vertex shader %s\n", vShaderName.c_str());
		return false;
	}
	
	// Compile fragment shader
	glCompileShader(FS);
	GLSL::printError();
	glGetShaderiv(FS, GL_COMPILE_STATUS, &rc);
	GLSL::printShaderInfoLog(FS);
	if(!rc) {
		printf("Error compiling fragment shader %s\n", fShaderName.c_str());
		return false;
	}
	
	// Create the program and link
	   ShadeProg = glCreateProgram();
	   glAttachShader(ShadeProg, VS);
	   glAttachShader(ShadeProg, FS);
	   glLinkProgram(ShadeProg);
   
	   GLSL::printError();
	   glGetProgramiv(ShadeProg, GL_LINK_STATUS, &rc);
	   GLSL::printProgramInfoLog(ShadeProg);
	   if(!rc) {
		   printf("Error linking shaders %s and %s\n", vShaderName.c_str(), fShaderName.c_str());
		   return false;
	   }

   /* get handles to attribute data */
    h_aPosition = GLSL::getAttribLocation(ShadeProg, "aPosition");
    h_aNormal = GLSL::getAttribLocation(ShadeProg, "aNormal");
    h_uProjMatrix = GLSL::getUniformLocation(ShadeProg, "uProjMatrix");
    h_uViewMatrix = GLSL::getUniformLocation(ShadeProg, "uViewMatrix");
    h_uModelMatrix = GLSL::getUniformLocation(ShadeProg, "uModelMatrix");
    h_uLightPos = GLSL::getUniformLocation(ShadeProg, "uLightPos");
    h_uMatAmb = GLSL::getUniformLocation(ShadeProg, "UaColor");
    h_uMatDif = GLSL::getUniformLocation(ShadeProg, "UdColor");
    h_uMatSpec = GLSL::getUniformLocation(ShadeProg, "UsColor");
    h_uMatShine = GLSL::getUniformLocation(ShadeProg, "Ushine");
    h_uShadeM = GLSL::getUniformLocation(ShadeProg, "uShadeModel");
    uFlag = GLSL::getUniformLocation(ShadeProg, "flag");
    uNorFlag = GLSL::getUniformLocation(ShadeProg, "norFlag");
	
	assert(glGetError() == GL_NO_ERROR);
	return true;
}

void setLeaderPos()
{
   float radX, radY;
   float rad= atan(leaderPoint.z/leaderPoint.x);
      radX = radius * cos(rad + curTime);
      radY = radius * sin(rad + curTime);
      if(leaderPoint.x < 0)
      {
        radX = -radX;
        radY = -radY;
      }

    newLeaderPos = vec3(radX, 0, radY);
}

vec3 setFollowDir(float x, float z)
{

  return vec3(newLeaderPos.x - x, 0, newLeaderPos.z - z);
}


float setTheta(vec3 followDir)
{
   float theta;

   theta = acos(dot(normalize(followDir), normalize(vec3(-1,0,0))));
   theta *= 180/(3.14);

   if(followDir.x < 0 && followDir.z < 0)
   {
      theta *= -1;
   }

   return theta;
}

vec3 rule1(BOID bun)
{
  vec3 center(0, 0, 0);

  for(int i = 0; i < 20; i++)
  {
    if(bun.pos != buns[i].pos)
    {
      center += buns[i].pos;
    }
  }

  center /= 19;
  return (center - bun.pos) / 80.0f;
}

vec3 rule2(BOID bun)
{
  vec3 displacement =  vec3(0, 0, 0);

  for(int i = 0; i < 20; i++)
  {
    if(bun.pos != buns[i].pos)
    {
      if(glm::distance(bun.pos, buns[i].pos) < 1.3f)
      {
        displacement -= (buns[i].pos - bun.pos);
      }
    }
  }

  return displacement;
}

vec3 rule3(BOID bun)
{
  return vec3(0, 0, 0);
}

vec3 rule4(BOID bun)
{
  return vec3(newLeaderPos.x, 0, newLeaderPos.z)/20.0f;
}

vec3 rule5(BOID bun)
{
  // return (vec3(Eye.x + direction.x, 0, Eye.z + direction.z)
  //  - bun.pos) / 100.0f;

  return (vec3(Eye.x + direction.x, 0, Eye.z + direction.z)
    - bun.pos) / -30.0f;
}

void limVelocity(int index)
{
  float vlim = .2f;

  if(abs(glm::length(buns[index].velocity)) > vlim)
  {
    buns[index].velocity = (buns[index].velocity / glm::abs(glm::length(buns[index].velocity))) * vlim;
  }
}

void jump(int index)
{
  if(buns[index].jumping == true)
  {
    if(buns[index].pos.y <= 2.0f)
    {
      buns[index].pos.y += .1f;
    }
    else
    {
      buns[index].jumping = false;
      buns[index].falling = true;
    }
  }
  else if(buns[index].falling == true)
  {
    if(buns[index].pos.y > 0.5f)
    {
      buns[index].pos.y -= .1f;
    }
    else
    {
      buns[index].falling = false;
      canJump = true;
    }
  }

}

void scatter(int index)
{
  
}

mat4 rotateBun(BOID bun)
{
  float rotRad;

  rotRad = acos(dot(normalize(bun.pos), normalize(vec3(1,0,0))));

  rotRad *= 180.0f/3.14f;

  if(rotRad > 180)
  {
    rotRad = (rotRad - 180) * -1;
  }

  mat4 Rotate = rotate(mat4(1.0f), rotRad, vec3(0, 1, 0));

  return Rotate;
}

bool checkCollision(vec3 check)
{
  bool valid = true;
  vec3 vCheck = vec3(check.x, 1, check.z);

  if(glm::distance(vCheck, vec3(0, 0, 0)) > 45)
  {
    valid = false;
  }

  for(int i = 0; i < 20; i++)
  {
    vec3 treePos = vec3(treePositions[i+0], 1, treePositions[i+1]);

    if(glm::distance(vCheck, treePos) < 1)
    {
      valid = false;
    }
  }

  return  valid;
}

void checkShot()
{
  //Step 1
  float x = (2.0f * (width/2.0f)) / width - 1.0f;
  float y = 1.0f - (2.0f * (height/2.0f)) / height;
  float z = 1.0f;
  vec3 ray_nds = vec3 (x, y, z);

  //Step 2
  vec4 ray_clip = vec4 (ray_nds.x, ray_nds.y, -1.0, 1.0);

  //Step 3
  vec4 ray_eye = inverse(projection_matrix) * ray_clip;
  ray_eye = vec4 (ray_eye.x, ray_eye.y, -1.0, 0.0);

  //Step4
  vec3 ray_wor = vec3((inverse(view_matrix) * ray_eye).x,
    (inverse(view_matrix) * ray_eye).y, (inverse(view_matrix) * ray_eye).z);
  // don't forget to normalise the vector at some point
  ray_wor = normalize(ray_wor);

  mat4 rot = rotate(mat4(1.0f), 90.0f, vec3(0, 1, 0));
  ray_wor = vec3(vec4(ray_wor, 0) * rot);

  //Check every bunny
  for(int i = 0; i < 20; i++)
  {
    vec3 vpc = buns[i].pos - vec3(Eye.x + direction.x, 1, Eye.z + direction.z);
    vec3 pc = glm::dot(ray_wor, vpc) * ray_wor;

    //Infront and not behind
    if(glm::dot(vec3(vec4(vpc, 0) * rot), ray_wor) > 0)
    {
      //If the distance between the projection and center is less than the radius
      if(glm::abs(glm::distance(buns[i].pos, pc) - glm::distance(buns[i].pos, vec3(0, 0, 0))) < 0.05f)
      {
        buns[i].shot = true;
      }
    }

  }
}

void bunnyDie(int index, int indices)
{
  if(buns[index].size > 0.05f)
  {
    mat4 Scale = scale(mat4(1.0f), vec3(buns[index].size,
       buns[index].size, buns[index].size));
    mat4 Trans = translate(mat4(1.0f), buns[index].pos);
    mat4 com = Trans * Scale;
    buns[index].size -= 0.01f;

    safe_glUniformMatrix4fv(h_uModelMatrix, glm::value_ptr(com));
    glDrawElements(GL_TRIANGLES, indices, GL_UNSIGNED_INT, 0);
  }
}

void checkWin()
{
  bool win = true;
  for(int i = 0; i < 20; i++)
  {
    if(buns[i].shot == false)
    {
      win = false;
    }
  }

  if(win)
  {
    glfwSetWindowTitle(window, "You Win!");
  }
}

void drawGL()
{
	// Clear the screen
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	// Use our GLSL program
	glUseProgram(ShadeProg);
  glUniform3f(h_uLightPos, g_light.x, g_light.y, g_light.z);
  glUniform1i(h_uShadeM, g_SM);
	//Flag set to 0 is objects
	glUniform1i(uFlag, 0);
	glUniform1i(uNorFlag, norFlag);

  SetProjectionMatrix();
  SetView();

  SetMaterial(g_mat_id);
  SetModel(vec3(0, 0, -3), 45, 1);

  //SPHERE START
  // Enable and bind position array for drawing
	GLSL::enableVertexAttribArray(h_aPosition);
	glBindBuffer(GL_ARRAY_BUFFER, posBufObjS);
	glVertexAttribPointer(h_aPosition, 3, GL_FLOAT, GL_FALSE, 0, 0);
	
	// Enable and bind normal array for drawing
	GLSL::enableVertexAttribArray(h_aNormal);
	glBindBuffer(GL_ARRAY_BUFFER, norBufObjS);
	glVertexAttribPointer(h_aNormal, 3, GL_FLOAT, GL_FALSE, 0, 0);
	
	// Bind index array for drawing
	int nIndices = (int)sphere[0].mesh.indices.size();
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, indBufObjS);

 	SetMaterial(5);

 	mat4 Trans = glm::translate( glm::mat4(1.0f), vec3(0, 40.0f, -5.0f));
  mat4 ScaleY = glm::scale( glm::mat4(1.0f), glm::vec3(1.5, 1.5, 1.5));
  mat4 com = Trans*ScaleY;
 	safe_glUniformMatrix4fv(h_uModelMatrix, glm::value_ptr(com));

 	glDrawElements(GL_TRIANGLES, nIndices, GL_UNSIGNED_INT, 0);


  if(shooting)
  {
    setUpFireModel(nIndices);
    shooting = false;
  }

  GLSL::disableVertexAttribArray(h_aPosition);
	GLSL::disableVertexAttribArray(h_aNormal);
	glBindBuffer(GL_ARRAY_BUFFER, 0);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
	//SPHERE STOP

  // TREE START
  // Enable and bind position array for drawing
  GLSL::enableVertexAttribArray(h_aPosition);
  glBindBuffer(GL_ARRAY_BUFFER, posBufObjTree);
  glVertexAttribPointer(h_aPosition, 3, GL_FLOAT, GL_FALSE, 0, 0);
  
  // Enable and bind normal array for drawing
  GLSL::enableVertexAttribArray(h_aNormal);
  glBindBuffer(GL_ARRAY_BUFFER, norBufObjTree);
  glVertexAttribPointer(h_aNormal, 3, GL_FLOAT, GL_FALSE, 0, 0);
  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, indBufObjTree);
  
  // Bind index array for drawing
  nIndices = (int)tree[0].mesh.indices.size();

  mat4 Rotate;
  mat4 Scale;
  SetMaterial(5);

  for(int i = 0; i < 20; i += 2)
  {
    setUpTreeModel(treePositions[i], treePositions[i+1], nIndices);
  }

  GLSL::disableVertexAttribArray(h_aPosition);
  GLSL::disableVertexAttribArray(h_aNormal);
  glBindBuffer(GL_ARRAY_BUFFER, 0);
  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
  // TREE STOP

  // Gun START
  // Enable and bind position array for drawing
  GLSL::enableVertexAttribArray(h_aPosition);
  glBindBuffer(GL_ARRAY_BUFFER, posBufObjGun);
  glVertexAttribPointer(h_aPosition, 3, GL_FLOAT, GL_FALSE, 0, 0);
  
  // Enable and bind normal array for drawing
  GLSL::enableVertexAttribArray(h_aNormal);
  glBindBuffer(GL_ARRAY_BUFFER, norBufObjGun);
  glVertexAttribPointer(h_aNormal, 3, GL_FLOAT, GL_FALSE, 0, 0);
  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, indBufObjGun);
  
  // Bind index array for drawing
  nIndices = (int)gun[0].mesh.indices.size();

  setUpGunModel(nIndices);

  GLSL::disableVertexAttribArray(h_aPosition);
  GLSL::disableVertexAttribArray(h_aNormal);
  glBindBuffer(GL_ARRAY_BUFFER, 0);
  glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
  // Gun STOP

	// Enable and bind position array for drawing
	GLSL::enableVertexAttribArray(h_aPosition);
	glBindBuffer(GL_ARRAY_BUFFER, posBufObjB);
	glVertexAttribPointer(h_aPosition, 3, GL_FLOAT, GL_FALSE, 0, 0);
	
	// Enable and bind normal array for drawing
	GLSL::enableVertexAttribArray(h_aNormal);
	glBindBuffer(GL_ARRAY_BUFFER, norBufObjB);
	glVertexAttribPointer(h_aNormal, 3, GL_FLOAT, GL_FALSE, 0, 0);
	
	// Bind index array for drawing
	nIndices = (int)bunny[0].mesh.indices.size();
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, indBufObjB);
	
	float theta;
  mat4 Trans2;

 	 //Draw Bunnies
 	 for(int i = 0; i < 20; i++)
 	 {
       setLeaderPos();
     	 SetMaterial(i%6);
       vec3 v1, v2, v3, v4;

       if(!buns[i].shot)
       {

         v1 = rule1(buns[i]);
         v2 = rule2(buns[i]);
         v3 = rule3(buns[i]);
         v4 = rule4(buns[i]);

         buns[i].velocity += v1 + v2 + v3 + v4;

         if(glm::abs(glm::distance(buns[i].pos,
          vec3(Eye.x + direction.x, 0, Eye.z + direction.z))) < 10)
         {
          buns[i].velocity += rule5(buns[i]);
         }

         limVelocity(i);

         if(checkCollision(buns[i].pos + buns[i].velocity))
         {
          buns[i].pos += vec3(buns[i].velocity.x, 0, buns[i].velocity.z);
         }
         // else
         // {
         //  buns[i].pos += vec3(-buns[i].velocity.x, 0, -buns[i].velocity.z);
         // }

         Trans = translate(mat4(1.0f), vec3(buns[i].pos.x, buns[i].pos.y, buns[i].pos.z));//buns[i].pos);
         if(canJump)
         {
           if(!buns[i].falling && !buns[i].jumping)
           {
              buns[i].jumping = true;
           }
           canJump = false;
         }

         jump(i);

         if(shooting)
         {
          scatter(i);
         }

         Scale = scale(mat4(1.0f), vec3(0.5f, 0.5f, 0.5f));
         Rotate = rotateBun(buns[i]);

         com = Trans * Scale * Rotate;

       	 safe_glUniformMatrix4fv(h_uModelMatrix, glm::value_ptr(com));
       	 glDrawElements(GL_TRIANGLES, nIndices, GL_UNSIGNED_INT, 0);
       }
       else
       {
        bunnyDie(i, nIndices);
       }

 	 }

 	curTime += .01f;

  glUniform1i(uFlag, 1);


  GLSL::disableVertexAttribArray(h_aPosition);
	GLSL::disableVertexAttribArray(h_aNormal);
	glBindBuffer(GL_ARRAY_BUFFER, 0);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);

	SetModel(vec3(0), 0, 1);

	// draw the ground
  glEnableVertexAttribArray(h_aPosition);
  glBindBuffer(GL_ARRAY_BUFFER, posBufObjG);
  glVertexAttribPointer( h_aPosition, 3,  GL_FLOAT, GL_FALSE, 0, (void*)0);
	GLSL::enableVertexAttribArray(h_aNormal);
	glBindBuffer(GL_ARRAY_BUFFER, norBufObjG);
	glVertexAttribPointer(h_aNormal, 3, GL_FLOAT, GL_FALSE, 0, 0);

  glDrawArrays(GL_TRIANGLES, 0, 6);

  GLSL::disableVertexAttribArray(h_aPosition);
	GLSL::disableVertexAttribArray(h_aNormal);
	glBindBuffer(GL_ARRAY_BUFFER, 0);
	
   // Disable and unbind
	glBindBuffer(GL_ARRAY_BUFFER, 0);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);

	glUseProgram(0);
	assert(glGetError() == GL_NO_ERROR);
	
}

void window_size_callback(GLFWwindow* window, int w, int h){
	glViewport(0, 0, (GLsizei)w, (GLsizei)h);
	g_width = w;
	g_height = h;
}

void key_callback(GLFWwindow* window, int key, int scancode, int action, int mods)
{
    
    if(key == GLFW_KEY_W && action == GLFW_PRESS)
    {
      if(checkCollision(direction + viewVec * moveSpeed))
      {
     	  direction += viewVec * moveSpeed;
      }
    }

    if(key == GLFW_KEY_S && action == GLFW_PRESS)
    {
      if(checkCollision(direction - viewVec * moveSpeed))
      {
        direction -= viewVec * moveSpeed;
      }
    }

    if (key == GLFW_KEY_D && action == GLFW_PRESS)
    {
      if(checkCollision(direction + glm::cross(viewVec, up) * moveSpeed))
      {
        direction += glm::cross(viewVec, up) * moveSpeed;
      }
    }

    if (key == GLFW_KEY_A && action == GLFW_PRESS)
    {
      if(checkCollision(direction - glm::cross(viewVec, up) * moveSpeed))
      {
        direction -= glm::cross(viewVec, up) * moveSpeed;
      }
    }
}

void mouse_button_callback(GLFWwindow* window, int button, int action, int mods)
{
  if (button == GLFW_MOUSE_BUTTON_LEFT && action == GLFW_PRESS)
  {
      checkShot();
      shooting = true;
  }
}

int main(int argc, char **argv)
{

  // Initialise GLFW
  if( !glfwInit() )
  {
      fprintf( stderr, "Failed to initialize GLFW\n" );
      return -1;
  }

  radius = sqrt(leaderPoint.x * leaderPoint.x +
    leaderPoint.z * leaderPoint.z);

  glfwWindowHint(GLFW_SAMPLES, 4);
  glfwWindowHint(GLFW_RESIZABLE,GL_FALSE);
  glfwWindowHint(GLFW_CONTEXT_VERSION_MAJOR, 2);
  glfwWindowHint(GLFW_CONTEXT_VERSION_MINOR, 1);

  // Open a window and create its OpenGL context
  g_width = 1024;
  g_height = 768;
  window = glfwCreateWindow( g_width, g_height, "Kill the Evil Graphics Bunnies", NULL, NULL);
  if( window == NULL ){
     fprintf( stderr, "Failed to open GLFW window. If you have an Intel GPU, they are not 3.3 compatible. Try the 2.1 version of the tutorials.\n" );
       glfwTerminate();
       return -1;
  }
  glfwMakeContextCurrent(window);
  glfwSetKeyCallback(window, key_callback);
  glfwSetWindowSizeCallback(window, window_size_callback);
  glfwSetMouseButtonCallback(window, mouse_button_callback);
  // Initialize GLEW
  if (glewInit() != GLEW_OK) {
    fprintf(stderr, "Failed to initialize GLEW\n");
    return -1;
  }

  // Ensure we can capture the escape key being pressed below
  glfwSetInputMode(window, GLFW_STICKY_KEYS, GL_TRUE);

  glEnable (GL_BLEND);
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	loadShapes("bunny.obj", bunny);
	loadShapes("sphere.obj", sphere);
	loadShapes("cube.obj", cube);
  loadShapes("tree.obj", tree);
  loadShapes("1911.obj", gun);


	glfwSetInputMode(window, GLFW_CURSOR, GLFW_CURSOR_DISABLED);//GLFW_CROSSHAIR_CURSOR);
	
	initGL();
	installShaders("vert.glsl", "frag.glsl");

	glClearColor(0.6f, 0.6f, 0.8f, 1.0f);

	for(int i = 0; i < 20; i++)
  {
    treePositions[i] = -30.0f + static_cast <float> (rand()) /(static_cast <float> (RAND_MAX/(50.0f)));
  }

  for(int i = 0; i < 20; i++)
  {
    buns[i].pos = vec3(-25.0f + static_cast <float> (rand()) /(static_cast <float> (RAND_MAX/(50.0f))),
      0,
      -25.0f + static_cast <float> (rand()) /(static_cast <float> (RAND_MAX/(50.0f))));
    buns[i].velocity = vec3(0, 0, 0);
    buns[i].jumping = false;
    buns[i].falling = false;
    buns[i].shot = false;
    buns[i].size = 0.5f;

  }

  for(int i = 0; i < 5; i++)
  {
    buls[i].pos = vec3(0, 0, 0);
    buls[i].speed = 10.0f;
    buls[i].inRange = true;
  }

  do
  {
      drawGL();
      // Swap buffers
      glfwSwapBuffers(window);
      glfwPollEvents();
      checkWin();

  } // Check if the ESC key was pressed or the window was closed
   while( glfwGetKey(window, GLFW_KEY_ESCAPE ) != GLFW_PRESS &&
      glfwWindowShouldClose(window) == 0 );

  // Close OpenGL window and terminate GLFW
  glfwTerminate();

	return 0;
}