#version 120

attribute vec4 aPosition;
attribute vec3 aNormal;
uniform mat4 uProjMatrix;
uniform mat4 uModelMatrix;
uniform mat4 uViewMatrix;
uniform int flag;
uniform int norFlag;
uniform vec3 uLightPos;
uniform vec3 UaColor;
uniform vec3 UdColor;
uniform vec3 UsColor;
uniform float Ushine;

varying vec3 vCol;
varying vec4 vNor;
varying vec3 vlightSrc;
varying vec3 vDiffuseClr;
varying vec3 vAmbientClr;
varying vec3 vSpecColor;
varying float vShine;
varying vec3 vViewVec;
varying vec3 vLightVec;

void main()
{
		vec3 norNormal = normalize(aNormal);

		gl_Position = uProjMatrix * uViewMatrix * uModelMatrix * aPosition;
		vNor = vec4(vec3(uViewMatrix * uModelMatrix * vec4(norNormal, 0)), 0);


		vec3 diffuseClr = UdColor;
		vec3 ambientClr = UaColor;
		vec3 specClr = UsColor;
		vec3 viewVec = normalize(vec3(0, 0, 0) - vec3(uViewMatrix * uModelMatrix * aPosition));
		vec3 lightVec = (uLightPos - vec3(uViewMatrix * uModelMatrix * aPosition));

		vCol = norNormal;
		vlightSrc = uLightPos;
		vViewVec = viewVec;
		vAmbientClr = UaColor;
		vSpecColor = UsColor;
		vLightVec = lightVec;
		vShine = Ushine;


		vDiffuseClr = diffuseClr;
			
}
